static char *ScheEdit_id = 
	"@(#)Copyright (C) H.Shirouzu 2006   ScheEdit.cpp	Ver0.90";
/* ========================================================================
	Project  Name			: Scheduler Entry Editor
	Module Name				: Main Module
	Create					: 2006-01-08(Sun)
	Update					: 2006-02-20(Mon)
	Copyright				: H.Shirouzu
	Reference				: 
	======================================================================== */

#include <windows.h>
#include "resource.h"

#undef WINCEOEM
#include <notify.h>

#define MAX_BUF			512
#define SCHEDULE_EDITOR	L"Scheduler Editor"
#define EVENT_DB		L"DB_notify_events"

#ifndef PROP_TAG
#define PROP_TAG(ulPropType,ulPropID)  ((((ULONG)(ulPropID))<<16)|((ULONG)(ulPropType)))
#endif

struct GlobalData {
	HWND		hDlg;
	HINSTANCE	hI;
	HANDLE		hDB;
	CEGUID		guid;
	CEOID		dbOid;
	CEOID		*oid;
	DWORD		oidNum;
} Gb;

struct {
	int		event;
	WCHAR	*str;
} NT_EVENT[] = {
	{ NOTIFICATION_EVENT_DEVICE_CHANGE,	L"DEVICE_CHANGE" },
	{ NOTIFICATION_EVENT_IR_DISCOVERED,	L"IR_DISCOVERED" },
	{ NOTIFICATION_EVENT_NET_CONNECT,	L"NET_CONNECT" },
	{ NOTIFICATION_EVENT_NET_DISCONNECT,L"NET_DISCONNECT" },
	{ NOTIFICATION_EVENT_OFF_AC_POWER,	L"OFF_AC_POWER" },
	{ NOTIFICATION_EVENT_ON_AC_POWER,	L"ON_AC_POWER" },
	{ NOTIFICATION_EVENT_RESTORE_END,	L"RESTORE_END" },
	{ NOTIFICATION_EVENT_RS232_DETECTED,L"RS232_DETECTED" },
	{ NOTIFICATION_EVENT_SYNC_END,		L"SYNC_END" },
	{ NOTIFICATION_EVENT_TIME_CHANGE,	L"TIME_CHANGE" },
	{ NOTIFICATION_EVENT_TZ_CHANGE,		L"TZ_CHANGE" },
	{ NOTIFICATION_EVENT_WAKEUP,		L"WAKEUP" },
	{ 0,								NULL }
};

void ClearInfo(void)
{
	::SetDlgItemText(Gb.hDlg, PATH_EDIT, L"");
	::SetDlgItemText(Gb.hDlg, ARG_EDIT, L"");
	::SetDlgItemText(Gb.hDlg, OID_EDIT, L"");
	::SetDlgItemText(Gb.hDlg, EVENT_EDIT, L"");
	::SetDlgItemText(Gb.hDlg, EVENT_STR_EDIT, L"");
	::SetDlgItemText(Gb.hDlg, UN_STATIC, L"");
}

/* ========================================================================
	Cxgf[^x[XT
 ======================================================================== */
BOOL FindEventDB(CEGUID *guid, CEOID *oid)
{
	WCHAR		buf[MAX_BUF];
	CEOIDINFO	info;
	HANDLE		hFind;
	BOOL		found = FALSE;

	CREATE_INVALIDGUID(guid);

	while (!found && ::CeEnumDBVolumes(guid, buf, MAX_BUF)) {
		if ((hFind = ::CeFindFirstDatabaseEx(guid, 0)) == INVALID_HANDLE_VALUE)
			continue;
		while ((*oid = ::CeFindNextDatabaseEx(hFind, guid))) {
			if (!::CeOidGetInfoEx(guid, *oid, &info) || info.wObjType != OBJTYPE_DATABASE)
				continue;
			if (wcscmp(info.infDatabase.szDbaseName, EVENT_DB) == 0) {
				found = TRUE;
				break;
			}
		}
		::CloseHandle(hFind);
	}
	return	found;
}

BOOL OpenEventDB(void)
{
	if (!FindEventDB(&Gb.guid, &Gb.dbOid))
		return	::MessageBox(Gb.hDlg, L"Can't find EventDB", SCHEDULE_EDITOR, MB_OKCANCEL), FALSE;
	Gb.hDB = ::CeOpenDatabaseEx(&Gb.guid, &Gb.dbOid, EVENT_DB, 0, CEDB_AUTOINCREMENT, NULL);
	return	Gb.hDB == INVALID_HANDLE_VALUE ? FALSE : TRUE;
}

int SetEventOids(void)
{
	CEPROPVAL	*props = NULL;
	DWORD		db_idx, size;
	WORD		num;

	if (::CeSeekDatabase(Gb.hDB, CEDB_SEEK_END, 0, &Gb.oidNum) == 0)
		return	0;
	::CeSeekDatabase(Gb.hDB, CEDB_SEEK_BEGINNING, 0, &db_idx);

	Gb.oid = new CEOID [++Gb.oidNum];

	for (DWORD i=0; i < Gb.oidNum; i++) {
		Gb.oid[i] = ::CeReadRecordPropsEx(Gb.hDB, CEDB_ALLOWREALLOC, &num, 0, (LPBYTE *)&props, &size, 0);
		::LocalFree(props);
	}

	return	Gb.oidNum;
}

WORD ReadEventInfo(int index, CEPROPVAL **props)
{
	WORD		num;
	CEOID		oid = Gb.oid[index];
	DWORD		size, db_idx;

	if (::CeSeekDatabase(Gb.hDB, CEDB_SEEK_CEOID, oid, &db_idx) != oid)
		return	0;

	if (::CeReadRecordPropsEx(Gb.hDB, CEDB_ALLOWREALLOC, &num, 0, (LPBYTE*)props, &size, 0) != oid)
		return	0;

	return	num;
}

BOOL ModifyEventInfo(int index, WCHAR *app, WCHAR *args, int event)
{
	CEOID		oid = Gb.oid[index];
	CEPROPVAL	*props = NULL;
	WORD		num;

	if ((num = ReadEventInfo(index, &props)) == 0)
		return	FALSE;

	for (int i=0; i < num; i++) {
		switch (props[i].propid) {
		case PROP_TAG(CEVT_LPWSTR, 1):
			props[i].val.lpwstr = app;
			break;

		case PROP_TAG(CEVT_LPWSTR, 2):
			props[i].val.lpwstr = args;
			break;

		case PROP_TAG(CEVT_UI4,    3):
			props[i].val.iVal = event;
			break;
		}
	}

	BOOL ret = ::CeWriteRecordProps(Gb.hDB, oid, num, props) == oid ? TRUE : FALSE;

	::LocalFree(props);
	::CeFlushDBVol(&Gb.guid);

	return	ret;
}

BOOL SetInfo(int index)
{
	WCHAR		wtmp[MAX_BUF];
	CEPROPVAL	*props = NULL;

	WORD	num = ReadEventInfo(index, &props);
	ClearInfo();

	if (Gb.oid == 0 || num <= 0)
		return	FALSE;

	::wsprintf(wtmp, L"%x", Gb.oid[index]);
	::SetDlgItemText(Gb.hDlg, OID_EDIT, wtmp);

	for (int i=0; i < num; i++) {
		switch (props[i].propid) {
		case PROP_TAG(CEVT_LPWSTR, 1):
			::SetDlgItemText(Gb.hDlg, PATH_EDIT, props[i].val.lpwstr);
			break;

		case PROP_TAG(CEVT_LPWSTR, 2):
			::SetDlgItemText(Gb.hDlg, ARG_EDIT, props[i].val.lpwstr);
			break;

		case PROP_TAG(CEVT_UI4,    3):
			::wsprintf(wtmp, L"%d", props[i].val.iVal);
			::SetDlgItemText(Gb.hDlg, EVENT_EDIT, wtmp);

			for (int j=0; NT_EVENT[j].event; j++) {
				if (props[i].val.iVal == NT_EVENT[j].event) {
					::SetDlgItemText(Gb.hDlg, EVENT_STR_EDIT, NT_EVENT[j].str);
					break;
				}
			}
			break;
		}
	}

	::LocalFree(props);

	return	TRUE;
}

BOOL SetList(void)
{
	ClearInfo();

	if (Gb.oid) {
		delete [] Gb.oid;
		Gb.oid = NULL;
		Gb.oidNum = 0;
	}
	::SendDlgItemMessage(Gb.hDlg, SCHEDULE_LIST, LB_RESETCONTENT, 0, 0);

	if (!SetEventOids())
		return	FALSE;

	for (DWORD i=0; i < Gb.oidNum; i++) {
		WCHAR	buf[10];
		::wsprintf(buf, L"%d", i+1);
		::SendDlgItemMessage(Gb.hDlg, SCHEDULE_LIST, LB_INSERTSTRING, (WPARAM)i, (LPARAM)buf);
	}

	::SendDlgItemMessage(Gb.hDlg, SCHEDULE_LIST, LB_SETCURSEL, 0, 0);
	SetInfo(0);

	return	TRUE;
}

BOOL ModifyInfo(int index)
{
	WCHAR	app[MAX_BUF], args[MAX_BUF];

	::GetDlgItemText(Gb.hDlg, PATH_EDIT, app, MAX_BUF);
	::GetDlgItemText(Gb.hDlg, ARG_EDIT, args, MAX_BUF);
	int	event = ::GetDlgItemInt(Gb.hDlg, EVENT_EDIT, 0, 0);

	BOOL	ret = ModifyEventInfo(index, app, args, event);

	SetInfo(index);
	return	ret;
}

BOOL DeleteInfo(int index)
{
	BOOL ret = ::CeDeleteRecord(Gb.hDB, Gb.oid[index]);
	::CeFlushDBVol(&Gb.guid);
	SetList();
	return	ret;
}

BOOL OnInitDialog(WPARAM wParam, LPARAM lParam)
{
	OpenEventDB();
	SetList();

	RECT	rc;
	::GetWindowRect(Gb.hDlg, &rc);
	int	cx = rc.right - rc.left;
	int	dx = (::GetSystemMetrics(SM_CXSCREEN) - cx) / 2;

	::SetWindowPos(Gb.hDlg, HWND_TOP, rc.left + dx, rc.top, 0, 0, SWP_NOSIZE|SWP_SHOWWINDOW);

	return TRUE;
}

BOOL OnCommand(WPARAM wParam, LPARAM lParam)
{
	int	index = ::SendDlgItemMessage(Gb.hDlg, SCHEDULE_LIST, LB_GETCURSEL, 0, 0);

	switch (LOWORD(wParam)) {
	case IDOK: case IDCANCEL:
		PostQuitMessage(0);
		return	TRUE;

	case SCHEDULE_LIST:
		if (index >= 0)
			SetInfo(index);
		return	TRUE;

	case MODIFY_BUTTON:
		if (index >= 0 && MessageBox(Gb.hDlg, L"Modify Entry?", SCHEDULE_EDITOR, MB_OKCANCEL) == IDOK)
			ModifyInfo(index);
		return	TRUE;

	case DELETE_BUTTON:
		if (index >= 0 && MessageBox(Gb.hDlg, L"Delete Entry?", SCHEDULE_EDITOR, MB_OKCANCEL) == IDOK)
			DeleteInfo(index);
		return	TRUE;

	case REFLESH_BUTTON:
		SetList();
		return	TRUE;
	}
	return	TRUE;
}

BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		Gb.hDlg = hDlg;
		return	OnInitDialog(wParam, lParam);

	case WM_COMMAND:
		return	OnCommand(wParam, lParam);
	}
    return FALSE;
}

/* ========================================================================
	WinMain
 ======================================================================== */
int WINAPI WinMain(HINSTANCE hI, HINSTANCE, LPTSTR cmdLine, int)
{
	MSG	msg;
	Gb.hI = hI;

	if (!::CreateDialog(hI, (LPTSTR)SCHEEDIT_DIALOG, 0, DialogProc))
		return	0;

	// Main message loop:
	while (::GetMessage(&msg, NULL, 0, 0)) {
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}

	return msg.wParam;
}


